Exodus 7.22

Functions
ex_get_elem_block.c File Reference
`#include "exodusII.h"`

## Functions
int | ex_get_elem_block (int exoid, ex_entity_id elem_blk_id, char *elem_type, void_int *num_elem_this_blk, void_int *num_nodes_per_elem, void_int *num_attr)

## Function Documentation

## ◆ ex_get_elem_block()

int ex_get_elem_block | ( | int | exoid,
|  | ex_entity_id | elem_blk_id,
|  | char * | elem_type,
|  | void_int * | num_elem_this_blk,
|  | void_int * | num_nodes_per_elem,
|  | void_int * | num_attr
| ) |  |

Deprecated:
  Use ex_get_block()(exoid, EX_ELEM_BLOCK, elem_blk_id, elem_type, num_elem_this_blk, num_nodes_per_elem, NULL, NULL, num_attr) instead

The function ex_get_elem_block() reads the parameters used to describe an element block. IDs of all element blocks stored can be determined by calling ex_get_elem_blk_ids().

Returns
  In case of an error, ex_get_elem_block() returns a negative number; a warning will return a positive number. Possible causes of errors include:
  - data file not properly opened with call to ex_create() or ex_open()
  - element block with specified ID is not stored in the data file.

Parameters

  [in] | exoid | exodus file ID returned from a previous call to ex_create() or ex_open().
  [in] | elem_blk_id | The element block ID.
  [out] | elem_type | Returned element typetype of elements in the element block. The maximum length of this string is `MAX_STR_LENGTH` .
  [out] | num_elem_this_blk | Returned number of elements in the element block.
  [out] | num_nodes_per_elem | Returned number of nodes per element in the element block.
  [out] | num_attr | Returned number of attributes per element in the element block.

As an example, the following code segment will read the parameters for the element block with an ID of 10 and read the connectivity and element attributes arrays from an open exodus file :

#include "exodusII.h"
int id, error, exoid, num_el_in_blk, num_nod_per_el, num_attr,
*connect;
float *attrib;
char elem_type[MAX_STR_LENGTH+1];
/* read element block parameters */
id = 10;
error = ex_get_elem_block(exoid, id, elem_type, &num_el_in_blk,
&num_nod_per_elem, &num_attr);
/* read element connectivity */
connect = (int *) calloc(num_nod_per_el*num_el_in_blk,
sizeof(int));
error = ex_get_elem_conn(exoid, id, connect);
/* read element block attributes */
attrib = (float *) calloc (num_attr * num_el_in_blk, sizeof(float));
error = ex_get_elem_attr (exoid, id, attrib);
/* Same result using non-deprecated functions */
error = ex_get_block(exoid, EX_ELEM_BLOCK, id, elem_type, &num_el_in_blk,
&num_nod_per_elem, 0, 0, &num_attr);
error = ex_get_conn (exoid, EX_ELEM_BLOCK, id, connect);
error = ex_get_attr (exoid, EX_ELEM_BLOCK, id, attrib);
ex_get_block
int ex_get_block(int exoid, ex_entity_type blk_type, ex_entity_id blk_id, char *elem_type, void_int *num_entries_this_blk, void_int *num_nodes_per_entry, void_int *num_edges_per_entry, void_int *num_faces_per_entry, void_int *num_attr_per_entry)
Definition: ex_get_block.c:63
error
error
Definition: ex_put_elem_var_tab.c:115
ex_get_attr
int ex_get_attr(int exoid, ex_entity_type obj_type, ex_entity_id obj_id, void *attrib)
Definition: ex_get_attr.c:59
ex_get_conn
int ex_get_conn(int exoid, ex_entity_type blk_type, ex_entity_id blk_id, void_int *nodeconn, void_int *edgeconn, void_int *faceconn)
Definition: ex_get_conn.c:56
MAX_STR_LENGTH
#define MAX_STR_LENGTH
Definition: exodusII.h:300
ex__obj_stats::exoid
int exoid
Definition: exodusII_int.h:666
ex_get_elem_attr
SEACAS_DEPRECATED int ex_get_elem_attr(int exoid, ex_entity_id elem_blk_id, void *attrib)
Definition: ex_get_elem_attr.c:71
ex_get_elem_block
SEACAS_DEPRECATED int ex_get_elem_block(int exoid, ex_entity_id elem_blk_id, char *elem_type, void_int *num_elem_this_blk, void_int *num_nodes_per_elem, void_int *num_attr)
Definition: ex_get_elem_block.c:101
exodusII.h
EX_ELEM_BLOCK
Definition: exodusII.h:261
ex_get_elem_conn
SEACAS_DEPRECATED int ex_get_elem_conn(int exoid, ex_entity_id elem_blk_id, void_int *connect)
Definition: ex_get_elem_conn.c:66